/*******************************************************************************
* @Copyright (c)    :(C)2020, Qingdao ieslab Co., Ltd
* @FileName         :hc32_adc_driver.c
* @Author           :Kv-L
* @Version          :V1.0
* @Date             :2020-07-01 17:51:43
* @Description      :the function of the entity of ADC
*******************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "UWater_adc_driver.h"
#include "UWater_timer1uS_driver.h"

#ifdef __cplusplus
extern "C" {
#endif

/* Private variables ---------------------------------------------------------*/
static u8 s_adc_stat = ADC_IDLE;			//ADC״̬
static u8 s_Adc_Status = ADC_OK;			//ADC״̬
static u32 *s_Adc_Conv_Result_Addr;			//ADCתָ
static u32 s_Adc_Time_Interval;			    //תʱ
static u8 *s_Adc_Return_Msg;				//ADCŷ״ָ̬
static u8 s_Adc_Conv_Channel_Num = 0;		//ADCת
static u32 AdcTargetConvResult[3] = {0};	//ADCĿͨתֵMIN;SUM;MAX
static en_adc_samp_ch_sel_t s_Adc_Target_Channel = AdcExInputCH0;		//ADCĿתͨ
static u8 s_Adc_Conv_Target_Num = 0;		//ADCĿת
static u32 s_ADC_Sam_TimeInterval = 0;// ADC
static u32 s_ADC_Sam_Timeout = 0;// ADCʱ


/* Private function prototypes -----------------------------------------------*/
static void My_GPIO_Init(void);
static void My_Adc_Init(void);


/*******************************************************************************
* @fun_name     void AdcStartConvert(u8 AdcChannel, u32 ConvNum, u32 *ConvResult, u8 *ConvIfDone)
* @brief        ADCӿ
* @param[in]    u8 AdcChannel:ADC channel
*               u32 ConvNum:convert num; 
*				u32 TimeInterval,    λms
*               u32 *ConvResult:result point
*               u8 *ConvIfDone:convert states point
* @param[out]   None
* @retval       None
* @other        None
*******************************************************************************/
void AdcStartConvert(u8 AdcChannel, u32 ConvNum, u32 TimeInterval, u32 *ConvResult, u8 *ConvIfDone)
{
	if(ConvNum < MINCONVNUM) //ת
    {
		ConvNum = MINCONVNUM;
    }
    if (ConvNum > MAXCONVNUM)   //ܳת
    {
        ConvNum = MAXCONVNUM;
    }
	
	s_Adc_Return_Msg = ConvIfDone;			
	if(AdcChannel > 25)
	{
		s_Adc_Status |= ADC_START_ERROR; //ʧ
		*s_Adc_Return_Msg = TRUE; //
		return;
	}

	s_Adc_Conv_Result_Addr = ConvResult;
	*s_Adc_Return_Msg = FALSE; //ɱ־
	s_Adc_Conv_Channel_Num = 0; //ת
	AdcTargetConvResult[SUM] = 0; //buf
	AdcTargetConvResult[MIN] = 0;
	AdcTargetConvResult[MAX] = 0;
	s_Adc_Status = ADC_OK; // ADC״̬
	s_Adc_Target_Channel = (en_adc_samp_ch_sel_t)AdcChannel;
	s_Adc_Conv_Target_Num = ConvNum;
	s_Adc_Time_Interval = TimeInterval;///5;   //תΪ5msʱ
	//s_Adc_Time_Interval = TimeInterval/5;   //תΪ5msʱ
	My_GPIO_Init(); //ùܽ
	Sysctrl_SetPeripheralGate(SysctrlPeripheralAdcBgr, TRUE); //ʹADC&BGRʱ
	Bgr_BgrEnable(); //ʹBGRģ
	Adc_Enable(); //ʹADCģ
	Set5msTimer(TIMER_5MS_ADC,1);//
	s_adc_stat = ADC_CFGADC;
}

/*******************************************************************************
* @fun_name     AdcMachineDriver
* @brief        ADC
* @param[in]    None
* @param[out]   None
* @retval       None
* @other        None
*******************************************************************************/
void AdcMachineDriver(void)
{
	switch(s_adc_stat)
    {
        case ADC_IDLE:       
		break;       
             
		case ADC_CFGADC:
        {
			if(0 == Check5msTimer(TIMER_5MS_ADC)) //ʱ5msȴADCģ鼰BGRģ
            {
			    My_Adc_Init();
				s_adc_stat = ADC_START;               
            }            
        }
		break;
		
        case ADC_START:
        {
			Adc_CfgSglChannel(s_Adc_Target_Channel); //ѡתͨ
			Adc_ClrIrqStatus(AdcMskIrqSgl); //嵥תɱ־
			Adc_SGL_Start(); //ADת
					
            s_ADC_Sam_TimeInterval = Timer1usGetTick();
            s_ADC_Sam_Timeout = Timer1usGetTick();
            //Set5msTimer(TIMER_5MS_ADC,s_Adc_Time_Interval);//ת
			//Set5msTimer(TIMER_5MS_ADC_OVERTIME,10);//50msʱ
			s_adc_stat = ADC_CONV;

        }
		break;
		
        case ADC_CONV:
        {
			if(TRUE == Adc_GetIrqStatus(AdcMskIrqSgl)) //ת
            {
				
                //Set5msTimer(TIMER_5MS_ADC_OVERTIME,10);//50msʱ
				//if(0 == Check5msTimer(TIMER_5MS_ADC))  //ת
                s_ADC_Sam_Timeout = Timer1usGetTick();//½мƳʱʱ
        if(Timer1usGetTick() - s_ADC_Sam_TimeInterval >= s_Adc_Time_Interval)
				{
					u32 tmp_value = 0;
					tmp_value = Adc_GetSglResult();   //16.5.15
					AdcTargetConvResult[SUM] += tmp_value;
					if(0 == s_Adc_Conv_Channel_Num)
					{
						AdcTargetConvResult[MAX] = tmp_value;
						AdcTargetConvResult[MIN] = tmp_value;
					}
					else
					{
						AdcTargetConvResult[MAX] = ((tmp_value > AdcTargetConvResult[MAX]) ? tmp_value : AdcTargetConvResult[MAX]);
						AdcTargetConvResult[MIN] = ((tmp_value < AdcTargetConvResult[MIN]) ? tmp_value : AdcTargetConvResult[MIN]);
					}
					if(++s_Adc_Conv_Channel_Num >= s_Adc_Conv_Target_Num) //趨ת
					{
						u32 tmp_target = 0;
						tmp_target = AdcTargetConvResult[SUM] - AdcTargetConvResult[MIN] - AdcTargetConvResult[MAX];
						*s_Adc_Conv_Result_Addr = tmp_target / (s_Adc_Conv_Target_Num - 2);
						s_adc_stat = ADC_END;
					}
					else
					{
						s_adc_stat = ADC_START;
					}
				}
			}
			else
			{
                if(Timer1usGetTick() - s_ADC_Sam_Timeout > ADC_TIMEOUT)//ADתʱ
				{
					Adc_SGL_Stop(); //ֹͣADת
					s_Adc_Status |= ADC_CONV_TIMEOUT; //תʱ
					s_adc_stat = ADC_END;
				}
			}		
        }
		break;
		
		case ADC_END:
        {
			Adc_Disable(); 	//رADCģ
			Bgr_BgrDisable(); //رBGRģ
			Sysctrl_SetPeripheralGate(SysctrlPeripheralAdcBgr, FALSE); //رADC&BGRʱ
			*s_Adc_Return_Msg = TRUE; //
			s_adc_stat = ADC_IDLE;            
        }
		break;
		
        default:
        break;        
    }
}

/*******************************************************************************
* @fun_name     u8 AdcIfIdle(void)
* @brief        ѯADCǷнӿ
* @param[in]    None
* @param[out]   u8 :TASK_IDLE | TASK_BUSY
* @retval       None
* @other        None
*******************************************************************************/
u8 AdcIfIdle(void)
{
	if (ADC_IDLE == s_adc_stat)
    {
		return TASK_IDLE;
	}
	else
	{
		return TASK_BUSY;
	}
}

/*******************************************************************************
* @fun_name     u8 AdcGetStatus(void)
* @brief        ȡADC״̬
* @param[in]    None
* @param[out]   0:; Bit1:; Bit2:תʱ
* @retval       None
* @other        None
*******************************************************************************/
u8 AdcGetStatus(void)
{
	return s_Adc_Status;
}
/*******************************************************************************
* @fun_name     AdcIfSleep
* @brief        ѯADCǷ߽ӿ
* @param[in]    None
* @param[out]   u8 :TRUE | FALSE
* @retval       None
* @other        None
*******************************************************************************/
u8 AdcIfSleep(void)
{
	u8 tmp_adc_if_sleep = 0;
	if (ADC_IDLE == s_adc_stat)
	{
		tmp_adc_if_sleep = TRUE;
	}
	else
	{
		tmp_adc_if_sleep = FALSE;
	}
	return tmp_adc_if_sleep;
}

/*******************************************************************************
* @fun_name     AdcPreSleep
* @brief        ADCǰ
* @param[in]    None
* @param[out]   None
* @retval       None
* @other        None
*******************************************************************************/
void AdcPreSleep(void)
{
	Adc_Disable();
    Bgr_BgrDisable();
    Sysctrl_SetPeripheralGate(SysctrlPeripheralAdcBgr, FALSE);
}

/*******************************************************************************
* @fun_name     AdcWakeSleep
* @brief        ADCǰ
* @param[in]    None
* @param[out]   None
* @retval       None
* @other        None
*******************************************************************************/
void AdcWakeSleep(void)
{
    ;//ѲADCʹǰٿ
}


/*****************************Private functions********************************/

/*******************************************************************************
* @fun_name     My_GPIO_Init
* @brief        GPIOʼ
* @param[in]    None
* @param[out]   None
* @retval       None
* @other        None
*******************************************************************************/
static void My_GPIO_Init(void)
{   
/*Configure these ADC pins in analog mode*/
#if ADC_IN0
    Gpio_SetAnalogMode(GpioPortA, GpioPin0);
#endif
#if ADC_IN1
    Gpio_SetAnalogMode(GpioPortA, GpioPin1);
#endif
#if ADC_IN2
    Gpio_SetAnalogMode(GpioPortA, GpioPin2);
#endif
#if ADC_IN3
    Gpio_SetAnalogMode(GpioPortA, GpioPin3);
#endif
#if ADC_IN4
    Gpio_SetAnalogMode(GpioPortA, GpioPin4);
#endif
#if ADC_IN5 
    Gpio_SetAnalogMode(GpioPortA, GpioPin5);
#endif
#if ADC_IN6
    Gpio_SetAnalogMode(GpioPortA, GpioPin6);
#endif
#if ADC_IN7
    Gpio_SetAnalogMode(GpioPortA, GpioPin7);
#endif
#if ADC_IN8
    Gpio_SetAnalogMode(GpioPortB, GpioPin0);
#endif
#if ADC_IN9
    Gpio_SetAnalogMode(GpioPortB, GpioPin1);
#endif
#if ADC_IN10
    Gpio_SetAnalogMode(GpioPortC, GpioPin0);
#endif
#if ADC_IN11
    Gpio_SetAnalogMode(GpioPortC, GpioPin1);
#endif
#if ADC_IN12
    Gpio_SetAnalogMode(GpioPortC, GpioPin2);
#endif
#if ADC_IN13
    Gpio_SetAnalogMode(GpioPortC, GpioPin3);
#endif
#if ADC_IN14
    Gpio_SetAnalogMode(GpioPortC, GpioPin4);
#endif
#if ADC_IN15
    Gpio_SetAnalogMode(GpioPortC, GpioPin5);
#endif
#if ADC_IN16
    Gpio_SetAnalogMode(GpioPortB, GpioPin2);
#endif
#if ADC_IN17
	Gpio_SetAnalogMode(GpioPortB, GpioPin10);
#endif
#if ADC_IN18
	Gpio_SetAnalogMode(GpioPortB, GpioPin11);
#endif
#if ADC_IN19
	Gpio_SetAnalogMode(GpioPortB, GpioPin12);
#endif
#if ADC_IN20
	Gpio_SetAnalogMode(GpioPortB, GpioPin13);
#endif
#if ADC_IN21
	Gpio_SetAnalogMode(GpioPortB, GpioPin14);
#endif
#if ADC_IN22
	Gpio_SetAnalogMode(GpioPortB, GpioPin15);
#endif
#if ADC_IN23
	Gpio_SetAnalogMode(GpioPortE, GpioPin15);
#endif
#if ADC_IN24
	Gpio_SetAnalogMode(GpioPortE, GpioPin14);
#endif
#if ADC_IN25
	Gpio_SetAnalogMode(GpioPortE, GpioPin13);
#endif    
}

/*******************************************************************************
* @fun_name     My_Adc_Init
* @brief        ADCʼ
* @param[in]    None
* @param[out]   None
* @retval       None
* @other        None
*******************************************************************************/
static void My_Adc_Init(void)
{
    /*!< ADC_CFGR fields of parameters that can be updated when no regular conversion is on-going */
    stc_adc_cfg_t              stcAdcCfg;

    DDL_ZERO_STRUCT(stcAdcCfg);
    
    ///< ADC ʼ
    stcAdcCfg.enAdcMode         = AdcSglMode;               ///<ģʽ-
    stcAdcCfg.enAdcClkDiv       = AdcMskClkDiv4;            ///<Ƶ-4
    stcAdcCfg.enAdcSampCycleSel = AdcMskSampCycle12Clk;     ///<-12
    stcAdcCfg.enAdcRefVolSel    = AdcMskRefVolSelInBgr2p5;  ///<οѹѡ-ڲ2.5V
    stcAdcCfg.enAdcOpBuf        = AdcMskBufDisable;         ///<OP BUF-
    stcAdcCfg.enInRef           = AdcMskInRefEnable;        ///<ڲοѹʹ-
    stcAdcCfg.enAdcAlign        = AdcAlignRight;            ///<ת뷽ʽ-
    Adc_Init(&stcAdcCfg);
}


#ifdef __cplusplus
}
#endif
/***************************************************************END OF FILE****/
